var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import * as React from 'react';
import Button from '@mui/material/Button';
import Box from '@mui/material/Box';
import { styled } from '@mui/material/styles';
import Grid from '@mui/material/Grid';
import DialogContent from '@mui/material/DialogContent';
import Typography from '@mui/material/Typography';
import DialogTitle from '@mui/material/DialogTitle';
import Identicon from './Identicon';
import { PermIdentityOutlined, ContentCopy, Launch } from '@mui/icons-material';
import { useDisconnect } from 'wagmi';
import StyledModal from './StyledModal';
import _useNetwork from '../useNetwork';
import useWebThreeAuth from '../useWebThreeAuth';
import { useAccount } from '../..';
import { Avatar } from '@mui/material';
var StyledButton = styled(Button)(function (_a) {
    var theme = _a.theme;
    return ({
        backgroundColor: theme.palette.background.paper,
        borderRadius: theme.shape.borderRadius,
        padding: '0.5 rem',
        height: '38px',
    });
});
var StyledBox = styled(Box)(function (_a) {
    var theme = _a.theme;
    return ({
        border: '1px',
        borderStyle: 'solid',
        borderColor: theme.palette.background.paper,
        borderRadius: theme.shape.borderRadius,
        padding: theme.spacing(1),
        height: '130px',
        display: 'flex',
        flexDirection: 'column',
        justifyContent: 'space-between',
    });
});
export default function ConnectedWallet() {
    var _a, _b;
    var _c = React.useState(false), open = _c[0], setOpen = _c[1];
    var chain = _useNetwork();
    var _d = useAccount(), address = _d.address, connector = _d.connector;
    var _e = useWebThreeAuth(), torusPlugin = _e.torusPlugin, web3auth = _e.web3auth, infos = _e.infos;
    var disconnect = useDisconnect().disconnect;
    var logout = function () {
        if (connector === 'Torus') {
            web3auth === null || web3auth === void 0 ? void 0 : web3auth.logout({ cleanup: true });
        }
        else {
            disconnect();
        }
    };
    var walletButton = connector !== 'Torus' && (_jsx(StyledButton, __assign({ onClick: function () { return setOpen(true); } }, { children: _jsxs(Grid, __assign({ container: true, alignItems: "center", spacing: 1 }, { children: [_jsx(Grid, __assign({ item: true }, { children: _jsx(Typography, __assign({ color: "text.primary" }, { children: address &&
                            "".concat(address.slice(0, 6), "...").concat(address.slice(address.length - 4, address.length)) }), void 0) }), void 0), _jsx(Grid, __assign({ item: true }, { children: _jsx(Identicon, { size: 16 }, void 0) }), void 0)] }), void 0) }), void 0));
    var emailAvatar = connector === 'Torus' && infos && (_jsx(Avatar, __assign({ sx: { cursor: 'pointer' }, onClick: function () { return setOpen(true); }, src: infos.profileImage }, { children: !infos.profileImage && _jsx(PermIdentityOutlined, {}, void 0) }), void 0));
    return (_jsxs(_Fragment, { children: [_jsx(Grid, __assign({ container: true, spacing: 1, alignItems: "center" }, { children: _jsxs(Grid, __assign({ item: true }, { children: [walletButton, emailAvatar] }), void 0) }), void 0), _jsxs(StyledModal, __assign({ maxWidth: "xs", fullWidth: true, open: open, onClose: function () { return setOpen(false); }, "aria-labelledby": "alert-dialog-title", "aria-describedby": "alert-dialog-description" }, { children: [_jsx(DialogTitle, __assign({ id: "alert-dialog-title" }, { children: "Account" }), void 0), _jsx(DialogContent, { children: _jsxs(StyledBox, { children: [_jsxs(Grid, __assign({ container: true, alignItems: "center", justifyContent: "space-between" }, { children: [_jsx(Grid, __assign({ item: true }, { children: _jsxs(Typography, __assign({ color: "text.primary" }, { children: ["Connected with ", connector] }), void 0) }), void 0), _jsx(Grid, __assign({ item: true }, { children: _jsx(Button, __assign({ color: "primary", onClick: function () {
                                                    setOpen(false);
                                                    logout();
                                                } }, { children: "Logout" }), void 0) }), void 0)] }), void 0), _jsxs(Grid, __assign({ container: true, alignItems: "center", spacing: 1 }, { children: [_jsx(Grid, __assign({ item: true }, { children: _jsx(Identicon, { size: 20 }, void 0) }), void 0), _jsx(Grid, __assign({ item: true }, { children: _jsx(Typography, __assign({ color: "text.primary", variant: "h5", fontWeight: 500 }, { children: address &&
                                                    "".concat(address.slice(0, 6), "...").concat(address.slice(address.length - 4, address.length)) }), void 0) }), void 0)] }), void 0), _jsxs(Grid, __assign({ container: true, alignItems: "center", spacing: 1 }, { children: [connector === 'Torus' && torusPlugin && (_jsx(Grid, __assign({ item: true }, { children: _jsx(Button, __assign({ startIcon: _jsx(Launch, {}, void 0), color: "primary", disableElevation: true, onClick: function () {
                                                    return torusPlugin.torusWalletInstance.showWallet('home');
                                                } }, { children: "Open Wallet" }), void 0) }), void 0)), connector === 'Torus' && torusPlugin && (_jsx(Grid, __assign({ item: true }, { children: _jsx(Button, __assign({ startIcon: _jsx(Launch, {}, void 0), color: "primary", disableElevation: true, onClick: function () {
                                                    return torusPlugin.torusWalletInstance.showWallet('topup');
                                                } }, { children: "Buy crypto" }), void 0) }), void 0)), connector !== 'Torus' && (_jsx(Grid, __assign({ item: true }, { children: _jsx(Button, __assign({ color: "primary", startIcon: _jsx(ContentCopy, {}, void 0), onClick: function () { return navigator.clipboard.writeText(address); } }, { children: "Copy Address" }), void 0) }), void 0)), connector !== 'Torus' && (_jsx(Grid, __assign({ item: true }, { children: _jsxs(Button, __assign({ color: "primary", startIcon: _jsx(Launch, {}, void 0), target: "_blank", href: "".concat((_a = chain === null || chain === void 0 ? void 0 : chain.blockExplorers) === null || _a === void 0 ? void 0 : _a.default.url, "/address/").concat(address) }, { children: ["View on ", (_b = chain === null || chain === void 0 ? void 0 : chain.blockExplorers) === null || _b === void 0 ? void 0 : _b.default.name] }), void 0) }), void 0))] }), void 0)] }, void 0) }, void 0)] }), void 0)] }, void 0));
}
